#include <linux/module.h>
#include <linux/export-internal.h>
#include <linux/compiler.h>

MODULE_INFO(name, KBUILD_MODNAME);

__visible struct module __this_module
__section(".gnu.linkonce.this_module") = {
	.name = KBUILD_MODNAME,
	.init = init_module,
#ifdef CONFIG_MODULE_UNLOAD
	.exit = cleanup_module,
#endif
	.arch = MODULE_ARCH_INIT,
};

MODULE_INFO(intree, "Y");

KSYMTAB_FUNC(tun_ptr_free, "_gpl", "");
KSYMTAB_FUNC(tun_get_socket, "_gpl", "");
KSYMTAB_FUNC(tun_get_tx_ring, "_gpl", "");

SYMBOL_CRC(tun_ptr_free, 0x4099f919, "_gpl");
SYMBOL_CRC(tun_get_socket, 0xc0d8011f, "_gpl");
SYMBOL_CRC(tun_get_tx_ring, 0x0b0adf03, "_gpl");

static const struct modversion_info ____versions[]
__used __section("__versions") = {
	{ 0xf9c9ed0d, "__s390_indirect_jump_r14" },
	{ 0x9b8d07aa, "strnlen" },
	{ 0x350c1395, "__fortify_panic" },
	{ 0x2f092421, "file_f_owner_allocate" },
	{ 0x837dc8e2, "fasync_helper" },
	{ 0x666e31e2, "__f_setown" },
	{ 0x44c10a52, "kvfree_call_rcu" },
	{ 0xa0571e4c, "netdev_info" },
	{ 0x9e4d91d5, "netif_carrier_on" },
	{ 0xc64a8d5e, "netif_carrier_off" },
	{ 0x6cd53887, "from_kgid_munged" },
	{ 0xe783e261, "sysfs_emit" },
	{ 0xc2af192b, "from_kuid_munged" },
	{ 0x0ff182e8, "nla_put" },
	{ 0xe6d2458e, "do_trace_netlink_extack" },
	{ 0xf96e39d7, "bpf_prog_destroy" },
	{ 0x037a0cba, "kfree" },
	{ 0x49608959, "migrate_disable" },
	{ 0xf84bd6ee, "bpf_stats_enabled_key" },
	{ 0xff5b0ef7, "__s390_indirect_jump_r1" },
	{ 0x4d7272e4, "migrate_enable" },
	{ 0xe94986d6, "sched_clock" },
	{ 0x8e0ca2b5, "__s390_indirect_jump_r4" },
	{ 0x5ea9d86f, "__skb_get_hash_symmetric_net" },
	{ 0x520eb720, "netif_tx_stop_all_queues" },
	{ 0x5ce82861, "dev_get_tstats64" },
	{ 0x13c49cc2, "_copy_from_user" },
	{ 0x178eba95, "memdup_user" },
	{ 0x8a680203, "crc32_le_arch" },
	{ 0x78041b8f, "byte_rev_table" },
	{ 0x92997ed8, "_printk" },
	{ 0x01403a03, "rtnl_link_register" },
	{ 0xe6de92dc, "misc_register" },
	{ 0xd2da1048, "register_netdevice_notifier" },
	{ 0x2b883940, "misc_deregister" },
	{ 0x7209d838, "rtnl_link_unregister" },
	{ 0x9d0d6206, "unregister_netdevice_notifier" },
	{ 0xe14314b1, "xdp_return_frame" },
	{ 0xdfd80448, "sk_skb_reason_drop" },
	{ 0x4f91fd51, "__wake_up_sync_key" },
	{ 0xe7ca6dbd, "kill_fasync" },
	{ 0x4521f00f, "bpf_prog_put" },
	{ 0x553222fd, "sk_alloc" },
	{ 0x8c0c1c78, "__kvmalloc_node_noprof" },
	{ 0xf0ea2318, "__mutex_init" },
	{ 0x44e9b7d0, "__init_waitqueue_head" },
	{ 0xae6aec76, "sock_init_data_uid" },
	{ 0x22ba3d82, "sk_free" },
	{ 0xd2504a8c, "arch_spin_lock_wait" },
	{ 0xfedb0d94, "skb_queue_purge_reason" },
	{ 0xc95d7f0f, "napi_disable" },
	{ 0x609f1c7e, "synchronize_net" },
	{ 0x6ed056cc, "xdp_rxq_info_unreg" },
	{ 0x950eb34e, "__list_del_entry_valid_or_report" },
	{ 0x860efa2c, "mutex_lock" },
	{ 0x009030e5, "__netif_napi_del_locked" },
	{ 0x86a8fb71, "mutex_unlock" },
	{ 0x0296695f, "refcount_warn_saturate" },
	{ 0x4a93ea70, "module_put" },
	{ 0xf7a6d12e, "skb_copy_datagram_iter" },
	{ 0x62f96037, "_copy_to_iter" },
	{ 0xf6afa533, "iov_iter_advance" },
	{ 0xf6ebc03b, "net_ratelimit" },
	{ 0xbc5fed55, "netdev_err" },
	{ 0xead58fb9, "print_hex_dump" },
	{ 0x1ea37f2f, "build_skb" },
	{ 0xdd8a35d2, "skb_put" },
	{ 0x2886bd17, "skb_set_owner_w" },
	{ 0xbcb36fe4, "hugetlb_optimize_vmemmap_key" },
	{ 0xe798236d, "jiffies" },
	{ 0x50fad434, "round_jiffies_up" },
	{ 0xc38c83b8, "mod_timer" },
	{ 0x4598efb2, "__s390_indirect_jump_r9" },
	{ 0xeb27df3f, "netdev_core_stats_inc" },
	{ 0x7aa1756e, "kvfree" },
	{ 0xf4954fb2, "security_tun_dev_attach" },
	{ 0x1be74748, "xdp_rxq_info_is_reg" },
	{ 0xfc2d965d, "netif_set_real_num_tx_queues" },
	{ 0x912afaf5, "netif_set_real_num_rx_queues" },
	{ 0xf04a4cb9, "lock_sock_nested" },
	{ 0x5691a617, "sk_attach_filter" },
	{ 0x6efdfe87, "release_sock" },
	{ 0xb67352c9, "__xdp_rxq_info_reg" },
	{ 0x21502306, "xdp_rxq_info_reg_mem_model" },
	{ 0xd9b8ab3c, "napi_enable" },
	{ 0xa9a3c657, "netif_napi_add_weight_locked" },
	{ 0xc6cbbc89, "capable" },
	{ 0xa3671e55, "__dev_get_by_name" },
	{ 0xefecd4b7, "ns_capable" },
	{ 0xda3d10a8, "security_tun_dev_open" },
	{ 0x38629a3c, "netdev_state_change" },
	{ 0x39461d6a, "in_egroup_p" },
	{ 0x4f1cd128, "security_tun_dev_create" },
	{ 0x527a1fac, "alloc_netdev_mqs" },
	{ 0xd81e2cd2, "register_netdevice" },
	{ 0xa88958a7, "netif_tx_wake_queue" },
	{ 0xa9621f99, "ether_setup" },
	{ 0x8676db46, "get_random_bytes" },
	{ 0xc95ca324, "dev_addr_mod" },
	{ 0x71d6b678, "ip_tunnel_header_ops" },
	{ 0x6496503d, "free_netdev" },
	{ 0x12241652, "napi_gro_receive" },
	{ 0x153e680e, "napi_complete_done" },
	{ 0xaad8c7d6, "default_wake_function" },
	{ 0x7f4c565b, "add_wait_queue" },
	{ 0xbfd9f046, "remove_wait_queue" },
	{ 0x01000e51, "schedule" },
	{ 0x7c362fca, "consume_skb" },
	{ 0x88db9f48, "__check_object_size" },
	{ 0x51965d43, "__kmalloc_noprof" },
	{ 0x3c3fce39, "__local_bh_enable_ip" },
	{ 0xae02dd45, "bpf_prog_get_type_dev" },
	{ 0xc3d79831, "kmalloc_caches" },
	{ 0x6137fe0c, "__kmalloc_cache_noprof" },
	{ 0x28aa6a67, "call_rcu" },
	{ 0x438610bd, "security_tun_dev_alloc_security" },
	{ 0xc6f46339, "init_timer_key" },
	{ 0x82ee90dc, "timer_delete_sync" },
	{ 0x50097088, "security_tun_dev_free_security" },
	{ 0xebafb39a, "flow_keys_basic_dissector" },
	{ 0x43bfe47d, "__skb_flow_dissect" },
	{ 0x317bf0a1, "skb_partial_csum_set" },
	{ 0x950c6761, "__pskb_pull_tail" },
	{ 0xa44f609a, "sk_filter_trim_cap" },
	{ 0x74893aba, "skb_clone_tx_timestamp" },
	{ 0x40fab7bd, "skb_tx_error" },
	{ 0xd2800691, "nf_conntrack_destroy" },
	{ 0x8761c87b, "rps_needed" },
	{ 0x9897250f, "skb_tstamp_tx" },
	{ 0xb65b5de3, "skb_copy_ubufs" },
	{ 0x0955a7fe, "___pskb_trim" },
	{ 0x8de79dc3, "xdp_do_redirect" },
	{ 0xdaf3b41a, "bpf_warn_invalid_xdp_action" },
	{ 0xc6d8c48f, "__tracepoint_xdp_exception" },
	{ 0x564405cb, "__cpu_online_mask" },
	{ 0x6b5e8910, "__traceiter_xdp_exception" },
	{ 0x0addc863, "xdp_return_frame_rx_napi" },
	{ 0xf354f037, "xdp_convert_zc_to_xdp_frame" },
	{ 0xbb7195a5, "xdp_warn" },
	{ 0xc7a4fbed, "rtnl_lock" },
	{ 0x6e720ff2, "rtnl_unlock" },
	{ 0x4b3cf3e5, "seq_printf" },
	{ 0x08f8acb4, "napi_get_frags" },
	{ 0xd89fcf6b, "iov_iter_single_seg_count" },
	{ 0x3da5c61a, "pskb_expand_head" },
	{ 0x91a488ac, "__netdev_alloc_frag_align" },
	{ 0xc0d5eaec, "vm_layout" },
	{ 0x337045fc, "vmemmap" },
	{ 0x5f27690f, "skb_page_frag_refill" },
	{ 0x0c66d819, "copy_page_from_iter" },
	{ 0x03b814ca, "bpf_dispatcher_xdp_func" },
	{ 0x146cc88f, "bpf_master_redirect_enabled_key" },
	{ 0x203fd7d3, "xdp_master_redirect" },
	{ 0xc308db6b, "__folio_put" },
	{ 0xb9681621, "xdp_do_flush" },
	{ 0x7696f8c7, "__list_add_valid_or_report" },
	{ 0x55f45774, "unregister_netdevice_queue" },
	{ 0x341bcfd6, "get_net_ns" },
	{ 0x481497b9, "open_related_ns" },
	{ 0x34f3484e, "security_tun_dev_attach_queue" },
	{ 0xcd504cde, "make_kgid" },
	{ 0x6b10bee1, "_copy_to_user" },
	{ 0x954e57af, "netdev_update_features" },
	{ 0x75b05cca, "sk_detach_filter" },
	{ 0x665ec295, "dev_get_mac_address" },
	{ 0x982e224a, "dev_set_mac_address_user" },
	{ 0x0d83a0a0, "make_kuid" },
	{ 0xf38f4c17, "init_user_ns" },
	{ 0x15538aa6, "from_kuid" },
	{ 0x47c04bf6, "call_netdevice_notifiers" },
	{ 0x22595269, "__module_get" },
	{ 0xc96e725d, "from_kgid" },
	{ 0x42b83a11, "sock_recv_errqueue" },
	{ 0x029d42bc, "net_hotdata" },
	{ 0xe438a9ce, "eth_type_trans" },
	{ 0xb6c1538e, "do_xdp_generic" },
	{ 0x0f5142c3, "netif_receive_skb" },
	{ 0x52029fc5, "__page_frag_cache_drain" },
	{ 0x8159ce39, "_copy_from_iter" },
	{ 0xf3c4fe1f, "iov_iter_npages" },
	{ 0xb1806e5b, "skb_copy_datagram_from_iter" },
	{ 0x4f827d75, "__s390_indirect_jump_r5" },
	{ 0x7cbe4dc2, "napi_schedule_prep" },
	{ 0x5ad66945, "sock_alloc_send_pskb" },
	{ 0x79ce162b, "zerocopy_sg_from_iter" },
	{ 0x8d03ba1a, "iov_iter_revert" },
	{ 0x5db31487, "skb_push" },
	{ 0xdfe9eb90, "eth_get_headlen" },
	{ 0x521f1006, "napi_gro_frags" },
	{ 0x955b7cc8, "__napi_schedule" },
	{ 0x626a6ab9, "ethtool_op_get_link" },
	{ 0xcad68b62, "ethtool_op_get_ts_info" },
	{ 0x4ff7d9e8, "passthru_features_check" },
	{ 0x8aa3b4f8, "eth_mac_addr" },
	{ 0xef4a04ff, "eth_validate_addr" },
	{ 0x5622fd2e, "module_layout" },
};

MODULE_INFO(depends, "");


MODULE_INFO(srcversion, "2FA7FF419B01F82B8A77ECF");
MODULE_INFO(rhelversion, "9.99");
