#include <linux/module.h>
#include <linux/export-internal.h>
#include <linux/compiler.h>

MODULE_INFO(name, KBUILD_MODNAME);

__visible struct module __this_module
__section(".gnu.linkonce.this_module") = {
	.name = KBUILD_MODNAME,
	.init = init_module,
#ifdef CONFIG_MODULE_UNLOAD
	.exit = cleanup_module,
#endif
	.arch = MODULE_ARCH_INIT,
};

MODULE_INFO(intree, "Y");

KSYMTAB_FUNC(vfio_assign_device_set, "_gpl", "");
KSYMTAB_FUNC(vfio_device_set_open_count, "_gpl", "");
KSYMTAB_FUNC(vfio_find_device_in_devset, "_gpl", "");
KSYMTAB_FUNC(_vfio_alloc_device, "_gpl", "");
KSYMTAB_FUNC(vfio_register_group_dev, "_gpl", "");
KSYMTAB_FUNC(vfio_register_emulated_iommu_dev, "_gpl", "");
KSYMTAB_FUNC(vfio_unregister_group_dev, "_gpl", "");
KSYMTAB_FUNC(vfio_mig_get_next_state, "_gpl", "");
KSYMTAB_FUNC(vfio_combine_iova_ranges, "_gpl", "");
KSYMTAB_FUNC(vfio_file_is_valid, "_gpl", "");
KSYMTAB_FUNC(vfio_file_enforced_coherent, "_gpl", "");
KSYMTAB_FUNC(vfio_file_set_kvm, "_gpl", "");
KSYMTAB_FUNC(vfio_info_cap_add, "_gpl", "");
KSYMTAB_FUNC(vfio_info_cap_shift, "", "");
KSYMTAB_FUNC(vfio_info_add_capability, "", "");
KSYMTAB_FUNC(vfio_set_irqs_validate_and_prepare, "", "");
KSYMTAB_FUNC(vfio_pin_pages, "", "");
KSYMTAB_FUNC(vfio_unpin_pages, "", "");
KSYMTAB_FUNC(vfio_dma_rw, "", "");
KSYMTAB_FUNC(vfio_file_iommu_group, "_gpl", "");
KSYMTAB_FUNC(vfio_file_is_group, "_gpl", "");
KSYMTAB_FUNC(vfio_file_has_dev, "_gpl", "");
KSYMTAB_FUNC(vfio_register_iommu_driver, "_gpl", "");
KSYMTAB_FUNC(vfio_unregister_iommu_driver, "_gpl", "");
KSYMTAB_FUNC(vfio_virqfd_enable, "_gpl", "");
KSYMTAB_FUNC(vfio_virqfd_disable, "_gpl", "");
KSYMTAB_FUNC(vfio_virqfd_flush_thread, "_gpl", "");
KSYMTAB_FUNC(vfio_iommufd_device_ictx, "_gpl", "");
KSYMTAB_FUNC(vfio_iommufd_get_dev_id, "_gpl", "");
KSYMTAB_FUNC(vfio_iommufd_physical_bind, "_gpl", "");
KSYMTAB_FUNC(vfio_iommufd_physical_unbind, "_gpl", "");
KSYMTAB_FUNC(vfio_iommufd_physical_attach_ioas, "_gpl", "");
KSYMTAB_FUNC(vfio_iommufd_physical_detach_ioas, "_gpl", "");
KSYMTAB_FUNC(vfio_iommufd_emulated_bind, "_gpl", "");
KSYMTAB_FUNC(vfio_iommufd_emulated_unbind, "_gpl", "");
KSYMTAB_FUNC(vfio_iommufd_emulated_attach_ioas, "_gpl", "");
KSYMTAB_FUNC(vfio_iommufd_emulated_detach_ioas, "_gpl", "");

SYMBOL_CRC(vfio_assign_device_set, 0xe85548c5, "_gpl");
SYMBOL_CRC(vfio_device_set_open_count, 0xc6984055, "_gpl");
SYMBOL_CRC(vfio_find_device_in_devset, 0x793fd726, "_gpl");
SYMBOL_CRC(_vfio_alloc_device, 0x8340388a, "_gpl");
SYMBOL_CRC(vfio_register_group_dev, 0xe88dd649, "_gpl");
SYMBOL_CRC(vfio_register_emulated_iommu_dev, 0xf9d646b4, "_gpl");
SYMBOL_CRC(vfio_unregister_group_dev, 0xbf98963c, "_gpl");
SYMBOL_CRC(vfio_mig_get_next_state, 0x8297db04, "_gpl");
SYMBOL_CRC(vfio_combine_iova_ranges, 0x6e2aa0f0, "_gpl");
SYMBOL_CRC(vfio_file_is_valid, 0x493baca0, "_gpl");
SYMBOL_CRC(vfio_file_enforced_coherent, 0xaef07cb0, "_gpl");
SYMBOL_CRC(vfio_file_set_kvm, 0xdd63f594, "_gpl");
SYMBOL_CRC(vfio_info_cap_add, 0x529db99e, "_gpl");
SYMBOL_CRC(vfio_info_cap_shift, 0x4232a0c3, "");
SYMBOL_CRC(vfio_info_add_capability, 0xf3411eb8, "");
SYMBOL_CRC(vfio_set_irqs_validate_and_prepare, 0xaf8a4a7f, "");
SYMBOL_CRC(vfio_pin_pages, 0xb531e34d, "");
SYMBOL_CRC(vfio_unpin_pages, 0xa6a5e5e5, "");
SYMBOL_CRC(vfio_dma_rw, 0xb0468a73, "");
SYMBOL_CRC(vfio_file_iommu_group, 0x75e584db, "_gpl");
SYMBOL_CRC(vfio_file_is_group, 0x4e238a9e, "_gpl");
SYMBOL_CRC(vfio_file_has_dev, 0x9d8d8f7a, "_gpl");
SYMBOL_CRC(vfio_register_iommu_driver, 0x1798a949, "_gpl");
SYMBOL_CRC(vfio_unregister_iommu_driver, 0x4c4fdce9, "_gpl");
SYMBOL_CRC(vfio_virqfd_enable, 0x738189c9, "_gpl");
SYMBOL_CRC(vfio_virqfd_disable, 0xf5adfa41, "_gpl");
SYMBOL_CRC(vfio_virqfd_flush_thread, 0xfbc61625, "_gpl");
SYMBOL_CRC(vfio_iommufd_device_ictx, 0x421b0824, "_gpl");
SYMBOL_CRC(vfio_iommufd_get_dev_id, 0xadf91a7f, "_gpl");
SYMBOL_CRC(vfio_iommufd_physical_bind, 0xeab59f2d, "_gpl");
SYMBOL_CRC(vfio_iommufd_physical_unbind, 0x1de185ed, "_gpl");
SYMBOL_CRC(vfio_iommufd_physical_attach_ioas, 0xeb83bd35, "_gpl");
SYMBOL_CRC(vfio_iommufd_physical_detach_ioas, 0x7a80badf, "_gpl");
SYMBOL_CRC(vfio_iommufd_emulated_bind, 0x683bdcbc, "_gpl");
SYMBOL_CRC(vfio_iommufd_emulated_unbind, 0x582d8d93, "_gpl");
SYMBOL_CRC(vfio_iommufd_emulated_attach_ioas, 0x7ebdc9ac, "_gpl");
SYMBOL_CRC(vfio_iommufd_emulated_detach_ioas, 0xec6d18fa, "_gpl");

static const struct modversion_info ____versions[]
__used __section("__versions") = {
	{ 0x680bea5b, "iova_bitmap_free" },
	{ 0x26599e90, "iommufd_vfio_compat_ioas_get_id" },
	{ 0xf3c4b01c, "iommufd_access_unpin_pages" },
	{ 0x78569adf, "ida_alloc_range" },
	{ 0x4d6d0bbc, "iommu_group_ref_get" },
	{ 0x09b98b19, "try_module_get" },
	{ 0xe3ec2f2b, "alloc_chrdev_region" },
	{ 0x39cd3327, "anon_inode_getfile" },
	{ 0xbf9a5a1e, "__init_rwsem" },
	{ 0x5e5a2ce6, "alloc_anon_inode" },
	{ 0x2b883940, "misc_deregister" },
	{ 0x7696f8c7, "__list_add_valid_or_report" },
	{ 0x49cd25ed, "alloc_workqueue" },
	{ 0x18cbd7a7, "iommufd_access_detach" },
	{ 0xb381ff9e, "ida_destroy" },
	{ 0x13c49cc2, "_copy_from_user" },
	{ 0xff8b56a9, "wait_for_completion_timeout" },
	{ 0x51965d43, "__kmalloc_noprof" },
	{ 0x55c5e826, "dev_set_name" },
	{ 0xbcdd5b99, "iommu_group_set_name" },
	{ 0xd2504a8c, "arch_spin_lock_wait" },
	{ 0x941f2aaa, "eventfd_ctx_put" },
	{ 0x17eec4b4, "__s390_indirect_jump_r7" },
	{ 0xaca0aef0, "complete" },
	{ 0xc5b6f236, "queue_work_on" },
	{ 0x6e9dd606, "__symbol_put" },
	{ 0x278c323a, "cdev_device_del" },
	{ 0xcce2e44f, "iommu_group_get" },
	{ 0x9cadbd3b, "__init_swait_queue_head" },
	{ 0x22a246bf, "class_destroy" },
	{ 0xf5a067bf, "iommu_group_dma_owner_claimed" },
	{ 0xa31d1dea, "__xa_erase" },
	{ 0x67e2272e, "refcount_dec_and_mutex_lock" },
	{ 0xf996c33c, "device_initialize" },
	{ 0x5241c816, "iommufd_device_attach" },
	{ 0x06c6a9d0, "fd_install" },
	{ 0x8d22bb58, "iommu_group_alloc" },
	{ 0xa737b736, "__s390_indirect_jump_r3" },
	{ 0x236c8c64, "memcpy" },
	{ 0x037a0cba, "kfree" },
	{ 0x91097b3b, "iommufd_access_pin_pages" },
	{ 0x2ebc67c6, "iput" },
	{ 0x7f4c565b, "add_wait_queue" },
	{ 0x3be69222, "iommufd_ctx_from_fd" },
	{ 0x5e67d20f, "iommufd_access_replace" },
	{ 0x89485687, "iommu_group_put" },
	{ 0x947cd02a, "iova_bitmap_alloc" },
	{ 0x6865e8fe, "__dynamic_dev_dbg" },
	{ 0xa44a1307, "interval_tree_iter_first" },
	{ 0x67ccf0c2, "iommufd_vfio_compat_ioas_create" },
	{ 0x3f4547a7, "put_unused_fd" },
	{ 0xcd0c29d2, "wait_for_completion_interruptible_timeout" },
	{ 0x92997ed8, "_printk" },
	{ 0x056e3cad, "cdev_device_add" },
	{ 0x0296695f, "refcount_warn_saturate" },
	{ 0x8e0ca2b5, "__s390_indirect_jump_r4" },
	{ 0xc4a63b82, "put_device" },
	{ 0x05317734, "iommufd_ctx_from_file" },
	{ 0xc6cbbc89, "capable" },
	{ 0x4a93ea70, "module_put" },
	{ 0xbd7426f1, "compat_ptr_ioctl" },
	{ 0x868784cb, "__symbol_get" },
	{ 0x4598efb2, "__s390_indirect_jump_r9" },
	{ 0x6e7943ec, "iommu_group_id" },
	{ 0xe3e423ac, "iommu_group_release_dma_owner" },
	{ 0xd7c5a85c, "fput" },
	{ 0xd3cf1c01, "down_write" },
	{ 0x41482d8b, "strndup_user" },
	{ 0xd2510a63, "up_write" },
	{ 0x5b745a3d, "xa_load" },
	{ 0x2be3bc8c, "iommufd_access_attach" },
	{ 0xd96babb4, "interval_tree_iter_next" },
	{ 0xd7110099, "class_create" },
	{ 0x9fb942c0, "iommufd_device_bind" },
	{ 0x8c03d20c, "destroy_workqueue" },
	{ 0x860efa2c, "mutex_lock" },
	{ 0x49109e8f, "__s390_indirect_jump_r10" },
	{ 0x7bfe1b99, "iova_bitmap_for_each" },
	{ 0xf9a06e0e, "ida_free" },
	{ 0x950eb34e, "__list_del_entry_valid_or_report" },
	{ 0x8db263d5, "iommufd_access_rw" },
	{ 0xf0ea2318, "__mutex_init" },
	{ 0x350c1395, "__fortify_panic" },
	{ 0x20895f76, "_dev_warn" },
	{ 0x41ed3cec, "eventfd_ctx_remove_wait_queue" },
	{ 0xee5291a7, "iommufd_access_destroy" },
	{ 0xf9c9ed0d, "__s390_indirect_jump_r14" },
	{ 0xe6de92dc, "misc_register" },
	{ 0x9166fc03, "__flush_workqueue" },
	{ 0x6b10bee1, "_copy_to_user" },
	{ 0xfb384d37, "kasprintf" },
	{ 0x103bafd6, "down_read" },
	{ 0xaa7a1f77, "__xa_cmpxchg" },
	{ 0xa5743a8c, "iommufd_device_to_id" },
	{ 0x48fef23a, "init_pseudo" },
	{ 0xff5b0ef7, "__s390_indirect_jump_r1" },
	{ 0xec59a131, "iommufd_device_to_ictx" },
	{ 0x84163072, "__s390_indirect_jump_r8" },
	{ 0x7230beea, "fdget" },
	{ 0x6091b333, "unregister_chrdev_region" },
	{ 0x86a8fb71, "mutex_unlock" },
	{ 0xa843805a, "get_unused_fd_flags" },
	{ 0x989e1516, "xa_destroy" },
	{ 0x4a3d5c74, "iommufd_ctx_put" },
	{ 0x543b15fe, "iommufd_access_create" },
	{ 0x6137fe0c, "__kmalloc_cache_noprof" },
	{ 0x56470118, "__warn_printk" },
	{ 0x0cc9d36c, "iommu_group_claim_dma_owner" },
	{ 0x966a4d81, "iommufd_device_detach" },
	{ 0x419fbc46, "device_iommu_capable" },
	{ 0x4f827d75, "__s390_indirect_jump_r5" },
	{ 0xdab5a1eb, "interval_tree_insert" },
	{ 0x889e414f, "__s390_indirect_jump_r11" },
	{ 0xfc614ccc, "simple_release_fs" },
	{ 0xd17eba33, "kill_anon_super" },
	{ 0xd772abfd, "iommufd_device_unbind" },
	{ 0x7aa1756e, "kvfree" },
	{ 0xb73ac429, "iommufd_ctx_has_group" },
	{ 0xe911df29, "eventfd_ctx_do_read" },
	{ 0xb4d7fb4f, "iommu_group_add_device" },
	{ 0xb1176e59, "try_wait_for_completion" },
	{ 0x8c0c1c78, "__kvmalloc_node_noprof" },
	{ 0x555ccb97, "up_read" },
	{ 0x09b53e14, "interval_tree_remove" },
	{ 0x7812675c, "cdev_init" },
	{ 0x36b69672, "iommufd_device_replace" },
	{ 0x5a596f33, "eventfd_ctx_fileget" },
	{ 0xc3d79831, "kmalloc_caches" },
	{ 0x4012df4f, "krealloc_noprof" },
	{ 0x4b9364ed, "iommu_group_remove_device" },
	{ 0xc394499e, "simple_pin_fs" },
	{ 0x2d3385d3, "system_wq" },
	{ 0x2f2c95c4, "flush_work" },
	{ 0x5622fd2e, "module_layout" },
};

MODULE_INFO(depends, "iommufd");


MODULE_INFO(srcversion, "ED48A496BB9411EB65ECE67");
MODULE_INFO(rhelversion, "9.99");
