#include <linux/module.h>
#include <linux/export-internal.h>
#include <linux/compiler.h>

MODULE_INFO(name, KBUILD_MODNAME);

__visible struct module __this_module
__section(".gnu.linkonce.this_module") = {
	.name = KBUILD_MODNAME,
	.init = init_module,
#ifdef CONFIG_MODULE_UNLOAD
	.exit = cleanup_module,
#endif
	.arch = MODULE_ARCH_INIT,
};

MODULE_INFO(intree, "Y");

KSYMTAB_DATA(nf_nat_sip_hooks, "_gpl", "");
KSYMTAB_FUNC(ct_sip_parse_request, "_gpl", "");
KSYMTAB_FUNC(ct_sip_get_header, "_gpl", "");
KSYMTAB_FUNC(ct_sip_parse_header_uri, "_gpl", "");
KSYMTAB_FUNC(ct_sip_parse_address_param, "_gpl", "");
KSYMTAB_FUNC(ct_sip_parse_numerical_param, "_gpl", "");
KSYMTAB_FUNC(ct_sip_get_sdp_header, "_gpl", "");

SYMBOL_CRC(nf_nat_sip_hooks, 0xf2d0e137, "_gpl");
SYMBOL_CRC(ct_sip_parse_request, 0xf57caa3f, "_gpl");
SYMBOL_CRC(ct_sip_get_header, 0xae83eedc, "_gpl");
SYMBOL_CRC(ct_sip_parse_header_uri, 0xef12399a, "_gpl");
SYMBOL_CRC(ct_sip_parse_address_param, 0x88ef7229, "_gpl");
SYMBOL_CRC(ct_sip_parse_numerical_param, 0x3aeeb5e8, "_gpl");
SYMBOL_CRC(ct_sip_get_sdp_header, 0xced5e259, "_gpl");

static const struct modversion_info ____versions[]
__used __section("__versions") = {
	{ 0xf9c9ed0d, "__s390_indirect_jump_r14" },
	{ 0x11089ac7, "_ctype" },
	{ 0xebbf1dba, "strncasecmp" },
	{ 0x609bcd98, "in6_pton" },
	{ 0xac5fcec0, "in4_pton" },
	{ 0x2cf56265, "__dynamic_pr_debug" },
	{ 0x20000329, "simple_strtoul" },
	{ 0x85abc85f, "strncmp" },
	{ 0x889e414f, "__s390_indirect_jump_r11" },
	{ 0xe9dae52e, "nf_ct_helper_init" },
	{ 0xb7e67f77, "nf_conntrack_helpers_register" },
	{ 0x92997ed8, "_printk" },
	{ 0xfebee424, "nf_conntrack_helpers_unregister" },
	{ 0x4598efb2, "__s390_indirect_jump_r9" },
	{ 0x17eec4b4, "__s390_indirect_jump_r7" },
	{ 0x5fc911d9, "nf_ct_helper_log" },
	{ 0x09033bed, "__nf_ip6_route" },
	{ 0x7f0f7a95, "dst_release" },
	{ 0xf2ecdce3, "__nf_ct_expect_find" },
	{ 0x9daff494, "nf_ct_expect_alloc" },
	{ 0xf5b36a20, "nf_ct_expect_init" },
	{ 0xe54347af, "nf_ct_expect_related_report" },
	{ 0x33700afc, "nf_ct_expect_put" },
	{ 0x89d99ee1, "__nf_ct_ext_find" },
	{ 0x63d01f51, "nf_ct_unexpect_related" },
	{ 0x2ab30193, "nf_ip_route" },
	{ 0xff5b0ef7, "__s390_indirect_jump_r1" },
	{ 0xd9cc99d7, "nf_conntrack_expect_lock" },
	{ 0x86e7da98, "nf_ct_remove_expect" },
	{ 0x3c3fce39, "__local_bh_enable_ip" },
	{ 0xd2504a8c, "arch_spin_lock_wait" },
	{ 0xc97ef3be, "__nf_ct_refresh_acct" },
	{ 0x950c6761, "__pskb_pull_tail" },
	{ 0xadf2c3e4, "skb_copy_bits" },
	{ 0xe798236d, "jiffies" },
	{ 0x1e0a0c24, "mod_timer_pending" },
	{ 0x42b3b1c9, "param_ops_ushort" },
	{ 0xe4fb7b07, "param_ops_int" },
	{ 0x804d5d51, "param_ops_uint" },
	{ 0x86c969ad, "param_array_ops" },
	{ 0x5622fd2e, "module_layout" },
};

MODULE_INFO(depends, "nf_conntrack");


MODULE_INFO(srcversion, "874DF5165C4DA6A0D2C7D3A");
MODULE_INFO(rhelversion, "9.99");
