#include <linux/module.h>
#include <linux/export-internal.h>
#include <linux/compiler.h>

MODULE_INFO(name, KBUILD_MODNAME);

__visible struct module __this_module
__section(".gnu.linkonce.this_module") = {
	.name = KBUILD_MODNAME,
	.init = init_module,
#ifdef CONFIG_MODULE_UNLOAD
	.exit = cleanup_module,
#endif
	.arch = MODULE_ARCH_INIT,
};

MODULE_INFO(intree, "Y");



static const struct modversion_info ____versions[]
__used __section("__versions") = {
	{ 0xb14def9c, "virtio_transport_purge_skbs" },
	{ 0x654e25e1, "virtio_transport_notify_recv_init" },
	{ 0xb5f6a005, "virtio_transport_release" },
	{ 0x337045fc, "vmemmap" },
	{ 0x694fc464, "virtqueue_enable_cb" },
	{ 0x49cd25ed, "alloc_workqueue" },
	{ 0x9d278a31, "virtio_transport_consume_skb_sent" },
	{ 0xdd8a35d2, "skb_put" },
	{ 0x3cca56fe, "vsock_for_each_connected_socket" },
	{ 0xd73a02c1, "virtqueue_detach_unused_buf" },
	{ 0x8c6f8e18, "virtio_transport_connect" },
	{ 0xd2504a8c, "arch_spin_lock_wait" },
	{ 0x17eec4b4, "__s390_indirect_jump_r7" },
	{ 0x4e855176, "virtio_transport_notify_set_rcvlowat" },
	{ 0xc5b6f236, "queue_work_on" },
	{ 0xd8838a81, "virtio_transport_stream_has_data" },
	{ 0x93c65528, "virtio_transport_stream_rcvhiwat" },
	{ 0x037a0cba, "kfree" },
	{ 0x43babd19, "sg_init_one" },
	{ 0x66fdeafc, "virtio_transport_dgram_bind" },
	{ 0x7e70da5d, "sk_error_report" },
	{ 0x6c64e406, "virtio_transport_notify_recv_pre_block" },
	{ 0x12b8f94b, "virtio_transport_dgram_enqueue" },
	{ 0xa6ad8e58, "virtio_transport_shutdown" },
	{ 0x8e0ca2b5, "__s390_indirect_jump_r4" },
	{ 0x6e084ad7, "virtio_transport_notify_send_post_enqueue" },
	{ 0xef428918, "virtio_transport_dgram_dequeue" },
	{ 0x85186237, "unregister_virtio_driver" },
	{ 0xa7f1bfbc, "__alloc_skb" },
	{ 0x03a81e69, "virtio_transport_stream_allow" },
	{ 0xd6601b74, "__s390_indirect_jump_r6" },
	{ 0xd2fb9244, "virtqueue_get_vring_size" },
	{ 0x6091797f, "synchronize_rcu" },
	{ 0x867c4d97, "virtio_transport_notify_send_init" },
	{ 0xdfd80448, "sk_skb_reason_drop" },
	{ 0x21fe788d, "virtio_transport_notify_send_pre_enqueue" },
	{ 0x8c03d20c, "destroy_workqueue" },
	{ 0x9af33f63, "virtio_transport_seqpacket_dequeue" },
	{ 0x860efa2c, "mutex_lock" },
	{ 0xa116a578, "virtio_transport_seqpacket_enqueue" },
	{ 0xa15235e0, "virtio_transport_seqpacket_has_data" },
	{ 0x1402b6c0, "virtio_transport_notify_recv_pre_dequeue" },
	{ 0x316cec7b, "virtio_transport_stream_enqueue" },
	{ 0x206c0be1, "virtqueue_disable_cb" },
	{ 0x8197d216, "virtio_transport_stream_dequeue" },
	{ 0x1f48de28, "vsock_core_unregister" },
	{ 0x3c3fce39, "__local_bh_enable_ip" },
	{ 0xf0ea2318, "__mutex_init" },
	{ 0x3acc7dee, "mutex_lock_interruptible" },
	{ 0x87bb5239, "vsock_core_register" },
	{ 0x77a5c40f, "virtqueue_add_sgs" },
	{ 0xf9c9ed0d, "__s390_indirect_jump_r14" },
	{ 0x4244dc79, "virtio_reset_device" },
	{ 0x2db4eb71, "virtio_transport_notify_poll_out" },
	{ 0x4195c620, "virtio_transport_notify_recv_post_dequeue" },
	{ 0xbabd30f5, "virtio_transport_dgram_allow" },
	{ 0x579fe9da, "__register_virtio_driver" },
	{ 0x24b8528f, "mutex_trylock" },
	{ 0x2e642be2, "virtqueue_get_buf" },
	{ 0xff5b0ef7, "__s390_indirect_jump_r1" },
	{ 0x615469f1, "virtio_transport_deliver_tap_pkt" },
	{ 0x7cea6643, "virtio_transport_read_skb" },
	{ 0x2f92cc9e, "virtqueue_kick" },
	{ 0x86a8fb71, "mutex_unlock" },
	{ 0xdea64602, "virtio_transport_stream_is_active" },
	{ 0x4f569281, "virtqueue_add_inbuf" },
	{ 0x51faaf9d, "virtio_transport_do_socket_init" },
	{ 0x6137fe0c, "__kmalloc_cache_noprof" },
	{ 0xe17cb3cb, "virtio_transport_notify_poll_in" },
	{ 0x948f03a1, "virtio_check_driver_offered_feature" },
	{ 0xb981ffdc, "virtio_transport_unsent_bytes" },
	{ 0x949de9ad, "virtio_transport_stream_has_space" },
	{ 0x7af92d2b, "virtio_transport_notify_send_pre_block" },
	{ 0x35818e94, "virtio_transport_notify_buffer_size" },
	{ 0xc07b05eb, "virtio_transport_destruct" },
	{ 0x0143ba27, "virtio_transport_recv_pkt" },
	{ 0xc3d79831, "kmalloc_caches" },
	{ 0x2f2c95c4, "flush_work" },
	{ 0x5622fd2e, "module_layout" },
};

MODULE_INFO(depends, "vmw_vsock_virtio_transport_common,vsock");

MODULE_ALIAS("virtio:d00000013v*");

MODULE_INFO(srcversion, "2FB4091555A5734CF8AB3B8");
MODULE_INFO(rhelversion, "9.99");
