#include <linux/module.h>
#include <linux/export-internal.h>
#include <linux/compiler.h>

MODULE_INFO(name, KBUILD_MODNAME);

__visible struct module __this_module
__section(".gnu.linkonce.this_module") = {
	.name = KBUILD_MODNAME,
	.init = init_module,
#ifdef CONFIG_MODULE_UNLOAD
	.exit = cleanup_module,
#endif
	.arch = MODULE_ARCH_INIT,
};

MODULE_INFO(intree, "Y");

KSYMTAB_FUNC(fcoe_ctlr_init, "", "");
KSYMTAB_FUNC(fcoe_ctlr_destroy, "", "");
KSYMTAB_FUNC(fcoe_ctlr_link_up, "", "");
KSYMTAB_FUNC(fcoe_ctlr_link_down, "", "");
KSYMTAB_FUNC(fcoe_ctlr_els_send, "", "");
KSYMTAB_FUNC(fcoe_ctlr_recv, "", "");
KSYMTAB_FUNC(fcoe_ctlr_recv_flogi, "", "");
KSYMTAB_FUNC(fcoe_wwn_from_mac, "_gpl", "");
KSYMTAB_FUNC(fcoe_libfc_config, "_gpl", "");
KSYMTAB_FUNC(fcoe_fcf_get_selected, "", "");
KSYMTAB_FUNC(fcoe_ctlr_set_fip_mode, "", "");
KSYMTAB_FUNC(fcoe_link_speed_update, "_gpl", "");
KSYMTAB_FUNC(__fcoe_get_lesb, "_gpl", "");
KSYMTAB_FUNC(fcoe_get_lesb, "_gpl", "");
KSYMTAB_FUNC(fcoe_ctlr_get_lesb, "_gpl", "");
KSYMTAB_FUNC(fcoe_wwn_to_str, "_gpl", "");
KSYMTAB_FUNC(fcoe_validate_vport_create, "_gpl", "");
KSYMTAB_FUNC(fcoe_get_wwn, "_gpl", "");
KSYMTAB_FUNC(fcoe_fc_crc, "_gpl", "");
KSYMTAB_FUNC(fcoe_start_io, "_gpl", "");
KSYMTAB_FUNC(fcoe_clean_pending_queue, "_gpl", "");
KSYMTAB_FUNC(fcoe_check_wait_queue, "_gpl", "");
KSYMTAB_FUNC(fcoe_queue_timer, "_gpl", "");
KSYMTAB_FUNC(fcoe_get_paged_crc_eof, "_gpl", "");
KSYMTAB_FUNC(fcoe_transport_attach, "", "");
KSYMTAB_FUNC(fcoe_transport_detach, "", "");
KSYMTAB_FUNC(fcoe_ctlr_device_add, "_gpl", "");
KSYMTAB_FUNC(fcoe_ctlr_device_delete, "_gpl", "");
KSYMTAB_FUNC(fcoe_fcf_device_delete, "_gpl", "");
KSYMTAB_FUNC(fcoe_fcf_device_add, "_gpl", "");

SYMBOL_CRC(fcoe_ctlr_init, 0xd9a5a0a4, "");
SYMBOL_CRC(fcoe_ctlr_destroy, 0xa62d646c, "");
SYMBOL_CRC(fcoe_ctlr_link_up, 0xae38e98f, "");
SYMBOL_CRC(fcoe_ctlr_link_down, 0xe7988464, "");
SYMBOL_CRC(fcoe_ctlr_els_send, 0xd38cafae, "");
SYMBOL_CRC(fcoe_ctlr_recv, 0x6027004e, "");
SYMBOL_CRC(fcoe_ctlr_recv_flogi, 0x6972201c, "");
SYMBOL_CRC(fcoe_wwn_from_mac, 0xc3f30cc0, "_gpl");
SYMBOL_CRC(fcoe_libfc_config, 0xa22bcc78, "_gpl");
SYMBOL_CRC(fcoe_fcf_get_selected, 0x70f2d009, "");
SYMBOL_CRC(fcoe_ctlr_set_fip_mode, 0x1a291a76, "");
SYMBOL_CRC(fcoe_link_speed_update, 0x97656021, "_gpl");
SYMBOL_CRC(__fcoe_get_lesb, 0x3af4b96d, "_gpl");
SYMBOL_CRC(fcoe_get_lesb, 0x9555ce35, "_gpl");
SYMBOL_CRC(fcoe_ctlr_get_lesb, 0x3e2e97ba, "_gpl");
SYMBOL_CRC(fcoe_wwn_to_str, 0xf167cb7a, "_gpl");
SYMBOL_CRC(fcoe_validate_vport_create, 0x16e4ca96, "_gpl");
SYMBOL_CRC(fcoe_get_wwn, 0x38932115, "_gpl");
SYMBOL_CRC(fcoe_fc_crc, 0x8340de90, "_gpl");
SYMBOL_CRC(fcoe_start_io, 0xbf6d4bed, "_gpl");
SYMBOL_CRC(fcoe_clean_pending_queue, 0x3bf52ea6, "_gpl");
SYMBOL_CRC(fcoe_check_wait_queue, 0x1d0ca21f, "_gpl");
SYMBOL_CRC(fcoe_queue_timer, 0xbac58840, "_gpl");
SYMBOL_CRC(fcoe_get_paged_crc_eof, 0xd66bd142, "_gpl");
SYMBOL_CRC(fcoe_transport_attach, 0x683e9787, "");
SYMBOL_CRC(fcoe_transport_detach, 0xf1629f60, "");
SYMBOL_CRC(fcoe_ctlr_device_add, 0xae87d6f1, "_gpl");
SYMBOL_CRC(fcoe_ctlr_device_delete, 0x0c61026d, "_gpl");
SYMBOL_CRC(fcoe_fcf_device_delete, 0x8d638928, "_gpl");
SYMBOL_CRC(fcoe_fcf_device_add, 0xc30e9878, "_gpl");

static const struct modversion_info ____versions[]
__used __section("__versions") = {
	{ 0xe7d8a0cf, "fc_rport_lookup" },
	{ 0x9c22d39b, "dev_get_stats" },
	{ 0x337045fc, "vmemmap" },
	{ 0x7696f8c7, "__list_add_valid_or_report" },
	{ 0x49cd25ed, "alloc_workqueue" },
	{ 0x804d5d51, "param_ops_uint" },
	{ 0xdd8a35d2, "skb_put" },
	{ 0x7f02188f, "__msecs_to_jiffies" },
	{ 0x51965d43, "__kmalloc_noprof" },
	{ 0x55c5e826, "dev_set_name" },
	{ 0x7c362fca, "consume_skb" },
	{ 0xec4574ad, "fc_lport_init" },
	{ 0xd2504a8c, "arch_spin_lock_wait" },
	{ 0x17eec4b4, "__s390_indirect_jump_r7" },
	{ 0x98de1c15, "snprintf" },
	{ 0xc5b6f236, "queue_work_on" },
	{ 0x9d50ed7e, "fc_rport_destroy" },
	{ 0x6b121938, "device_unregister" },
	{ 0xbab8fce0, "skb_dequeue" },
	{ 0xa737b736, "__s390_indirect_jump_r3" },
	{ 0x037a0cba, "kfree" },
	{ 0x394da907, "fc_rport_logoff" },
	{ 0xdc0e4855, "timer_delete" },
	{ 0x82ee90dc, "timer_delete_sync" },
	{ 0x5ecfeec6, "__per_cpu_offset" },
	{ 0xbd08d0bb, "fc_disc_init" },
	{ 0x9bf4f205, "fc_rport_login" },
	{ 0xfedb0d94, "skb_queue_purge_reason" },
	{ 0xb4e32191, "dump_stack" },
	{ 0x92997ed8, "_printk" },
	{ 0xfcc86249, "fc_linkdown" },
	{ 0x0296695f, "refcount_warn_saturate" },
	{ 0x8e0ca2b5, "__s390_indirect_jump_r4" },
	{ 0xb2fcb56d, "queue_delayed_work_on" },
	{ 0xc4a63b82, "put_device" },
	{ 0x9b8d07aa, "strnlen" },
	{ 0x1233b104, "skb_queue_tail" },
	{ 0x12882ee6, "sized_strscpy" },
	{ 0xbcb36fe4, "hugetlb_optimize_vmemmap_key" },
	{ 0xf864a631, "fc_lport_reset" },
	{ 0xf39fc7e1, "bus_unregister" },
	{ 0x629c8a30, "init_net" },
	{ 0x5b1c2d30, "skb_pull" },
	{ 0x6091797f, "synchronize_rcu" },
	{ 0xdfd80448, "sk_skb_reason_drop" },
	{ 0xc38c83b8, "mod_timer" },
	{ 0x8c03d20c, "destroy_workqueue" },
	{ 0x860efa2c, "mutex_lock" },
	{ 0x5db31487, "skb_push" },
	{ 0x49109e8f, "__s390_indirect_jump_r10" },
	{ 0xd97c39dc, "fc_lport_set_local_id" },
	{ 0x112b76cb, "fc_exch_recv" },
	{ 0x950eb34e, "__list_del_entry_valid_or_report" },
	{ 0x1a9a433c, "prandom_u32_state" },
	{ 0x53a1e8d9, "_find_next_bit" },
	{ 0x3c3fce39, "__local_bh_enable_ip" },
	{ 0xf0ea2318, "__mutex_init" },
	{ 0x718e2bb8, "__ethtool_get_link_ksettings" },
	{ 0x350c1395, "__fortify_panic" },
	{ 0xa534ecf9, "device_register" },
	{ 0xd96de8cb, "__sysfs_match_string" },
	{ 0x3dad9978, "cancel_delayed_work" },
	{ 0xe02e4444, "fc_vport_id_lookup" },
	{ 0x2548c032, "__cpu_possible_mask" },
	{ 0x379c5440, "fc_elsct_init" },
	{ 0x5c3c7387, "kstrtoull" },
	{ 0xf9c9ed0d, "__s390_indirect_jump_r14" },
	{ 0x9166fc03, "__flush_workqueue" },
	{ 0x844c3509, "fc_disc_config" },
	{ 0x017de3d5, "nr_cpu_ids" },
	{ 0x950c6761, "__pskb_pull_tail" },
	{ 0x59bd4d45, "fc_fcp_init" },
	{ 0x3ad6a4f7, "__netdev_alloc_skb" },
	{ 0x72359d03, "skb_trim" },
	{ 0x9d0d6206, "unregister_netdevice_notifier" },
	{ 0xe798236d, "jiffies" },
	{ 0xff5b0ef7, "__s390_indirect_jump_r1" },
	{ 0x3c3ff9fd, "sprintf" },
	{ 0xb0d7b662, "__dev_queue_xmit" },
	{ 0x8a680203, "crc32_le_arch" },
	{ 0x86a8fb71, "mutex_unlock" },
	{ 0xc6f46339, "init_timer_key" },
	{ 0xc308db6b, "__folio_put" },
	{ 0x6137fe0c, "__kmalloc_cache_noprof" },
	{ 0x03c12dfe, "cancel_work_sync" },
	{ 0x56470118, "__warn_printk" },
	{ 0xd2da1048, "register_netdevice_notifier" },
	{ 0xffeedf6a, "delayed_work_timer_fn" },
	{ 0xc147ae73, "dev_get_by_name" },
	{ 0xe666af72, "skb_clone" },
	{ 0x068f0c9f, "fc_seq_els_rsp_send" },
	{ 0xccd852d1, "alloc_pages_noprof" },
	{ 0x4f827d75, "__s390_indirect_jump_r5" },
	{ 0xb0ddd5a1, "fc_rport_flush_queue" },
	{ 0xe4fb7b07, "param_ops_int" },
	{ 0xe78cd731, "fc_rport_create" },
	{ 0x772e0b27, "_dev_printk" },
	{ 0xc3d79831, "kmalloc_caches" },
	{ 0x47d93310, "fc_exch_init" },
	{ 0x9858f364, "get_random_u8" },
	{ 0x7e27f50f, "bus_register" },
	{ 0x2d3385d3, "system_wq" },
	{ 0x60453e8c, "fc_linkup" },
	{ 0x5622fd2e, "module_layout" },
};

MODULE_INFO(depends, "libfc");


MODULE_INFO(srcversion, "38CF7EEE172F8884AD7B426");
MODULE_INFO(rhelversion, "9.99");
