#include <linux/module.h>
#include <linux/export-internal.h>
#include <linux/compiler.h>

MODULE_INFO(name, KBUILD_MODNAME);

__visible struct module __this_module
__section(".gnu.linkonce.this_module") = {
	.name = KBUILD_MODNAME,
	.init = init_module,
#ifdef CONFIG_MODULE_UNLOAD
	.exit = cleanup_module,
#endif
	.arch = MODULE_ARCH_INIT,
};

MODULE_INFO(intree, "Y");

KSYMTAB_FUNC(ip6_tnl_parse_tlv_enc_lim, "", "");
KSYMTAB_FUNC(ip6_tnl_get_cap, "", "");
KSYMTAB_FUNC(ip6_tnl_rcv_ctl, "_gpl", "");
KSYMTAB_FUNC(ip6_tnl_rcv, "", "");
KSYMTAB_FUNC(ip6_tnl_xmit_ctl, "_gpl", "");
KSYMTAB_FUNC(ip6_tnl_xmit, "", "");
KSYMTAB_FUNC(ip6_tnl_change_mtu, "", "");
KSYMTAB_FUNC(ip6_tnl_get_iflink, "", "");
KSYMTAB_FUNC(ip6_tnl_encap_add_ops, "", "");
KSYMTAB_FUNC(ip6_tnl_encap_del_ops, "", "");
KSYMTAB_FUNC(ip6_tnl_encap_setup, "_gpl", "");
KSYMTAB_FUNC(ip6_tnl_get_link_net, "", "");

SYMBOL_CRC(ip6_tnl_parse_tlv_enc_lim, 0xfb6233f3, "");
SYMBOL_CRC(ip6_tnl_get_cap, 0x37945ab4, "");
SYMBOL_CRC(ip6_tnl_rcv_ctl, 0x1b267a1d, "_gpl");
SYMBOL_CRC(ip6_tnl_rcv, 0x829abcd6, "");
SYMBOL_CRC(ip6_tnl_xmit_ctl, 0x0c4b1adf, "_gpl");
SYMBOL_CRC(ip6_tnl_xmit, 0x7aae4019, "");
SYMBOL_CRC(ip6_tnl_change_mtu, 0xf1eddcfe, "");
SYMBOL_CRC(ip6_tnl_get_iflink, 0xf8e38377, "");
SYMBOL_CRC(ip6_tnl_encap_add_ops, 0x4e6b7f40, "");
SYMBOL_CRC(ip6_tnl_encap_del_ops, 0x12bdef7b, "");
SYMBOL_CRC(ip6_tnl_encap_setup, 0x2a5f09e1, "_gpl");
SYMBOL_CRC(ip6_tnl_get_link_net, 0x9c00e348, "");

static const struct modversion_info ____versions[]
__used __section("__versions") = {
	{ 0xf9c9ed0d, "__s390_indirect_jump_r14" },
	{ 0x9a7a77ee, "ip6tun_encaps" },
	{ 0x0d542439, "__ipv6_addr_type" },
	{ 0x71957622, "ipv6_chk_addr_and_flags" },
	{ 0x995e4bbf, "dev_get_by_index_rcu" },
	{ 0x4f827d75, "__s390_indirect_jump_r5" },
	{ 0xf4c3ce01, "___ratelimit" },
	{ 0x92997ed8, "_printk" },
	{ 0x609f1c7e, "synchronize_net" },
	{ 0x437eb1df, "ipv6_mod_enabled" },
	{ 0x97fee5af, "register_pernet_device" },
	{ 0xe98282aa, "xfrm6_tunnel_register" },
	{ 0x01403a03, "rtnl_link_register" },
	{ 0x8022ce20, "xfrm6_tunnel_deregister" },
	{ 0x0276d40e, "unregister_pernet_device" },
	{ 0x0ff182e8, "nla_put" },
	{ 0x55f45774, "unregister_netdevice_queue" },
	{ 0xc95ca324, "dev_addr_mod" },
	{ 0xa415e9e4, "rt6_lookup" },
	{ 0x7f0f7a95, "dst_release" },
	{ 0xb39d0f5d, "__dev_get_by_index" },
	{ 0x9f54ead7, "gro_cells_destroy" },
	{ 0xada38766, "dst_cache_destroy" },
	{ 0x71d6b678, "ip_tunnel_header_ops" },
	{ 0x8676db46, "get_random_bytes" },
	{ 0x85670f1d, "rtnl_is_locked" },
	{ 0x56470118, "__warn_printk" },
	{ 0x7209d838, "rtnl_link_unregister" },
	{ 0x9c522339, "ip6_local_out" },
	{ 0x79d219c0, "__get_hash_from_flowi6" },
	{ 0xae39f80e, "dst_cache_init" },
	{ 0x12e9e0df, "gro_cells_init" },
	{ 0x9cdfb3f7, "sysctl_fb_tunnels_only_for_init_net" },
	{ 0x629c8a30, "init_net" },
	{ 0x527a1fac, "alloc_netdev_mqs" },
	{ 0xc6035835, "register_netdev" },
	{ 0x9b8d07aa, "strnlen" },
	{ 0x350c1395, "__fortify_panic" },
	{ 0x6496503d, "free_netdev" },
	{ 0x69197a08, "__xfrm_policy_check" },
	{ 0x2006850f, "__skb_ext_del" },
	{ 0xf1db1704, "nla_memcpy" },
	{ 0x452ba683, "ipv6_ext_hdr" },
	{ 0x950c6761, "__pskb_pull_tail" },
	{ 0xd81e2cd2, "register_netdevice" },
	{ 0x62849ac7, "dev_valid_name" },
	{ 0x12882ee6, "sized_strscpy" },
	{ 0x3c3ff9fd, "sprintf" },
	{ 0xe798236d, "jiffies" },
	{ 0x3e903560, "ip_tunnel_netlink_encap_parms" },
	{ 0x38629a3c, "netdev_state_change" },
	{ 0xefecd4b7, "ns_capable" },
	{ 0x13c49cc2, "_copy_from_user" },
	{ 0x6b10bee1, "_copy_to_user" },
	{ 0x0d83a0a0, "make_kuid" },
	{ 0xbce2712c, "ip6_redirect" },
	{ 0x2018f8e7, "ip6_update_pmtu" },
	{ 0xf6ebc03b, "net_ratelimit" },
	{ 0x2cf56265, "__dynamic_pr_debug" },
	{ 0x47df8e92, "ip6_route_output_flags" },
	{ 0x3289c1e0, "xfrm_lookup" },
	{ 0xff5b0ef7, "__s390_indirect_jump_r1" },
	{ 0x6240d9a4, "skb_scrub_packet" },
	{ 0xe496fa47, "skb_realloc_headroom" },
	{ 0x2886bd17, "skb_set_owner_w" },
	{ 0x7c362fca, "consume_skb" },
	{ 0x889e414f, "__s390_indirect_jump_r11" },
	{ 0x9de8dd25, "ipv6_push_frag_opts" },
	{ 0x5db31487, "skb_push" },
	{ 0x1d3db2aa, "dst_cache_get" },
	{ 0x17eec4b4, "__s390_indirect_jump_r7" },
	{ 0xa737b736, "__s390_indirect_jump_r3" },
	{ 0xdaa15380, "ipv6_dev_get_saddr" },
	{ 0xadf2c3e4, "skb_copy_bits" },
	{ 0xd2a40d15, "dst_cache_set_ip6" },
	{ 0xd6601b74, "__s390_indirect_jump_r6" },
	{ 0x8bae7b6c, "neigh_destroy" },
	{ 0x9e73f396, "ip6_dst_hoplimit" },
	{ 0x0296695f, "refcount_warn_saturate" },
	{ 0xb2d7b91a, "iptunnel_handle_offloads" },
	{ 0xacb48d2f, "icmpv6_ndo_send" },
	{ 0xb783b12e, "icmp_ndo_send" },
	{ 0xdfd80448, "sk_skb_reason_drop" },
	{ 0xe666af72, "skb_clone" },
	{ 0x5b1c2d30, "skb_pull" },
	{ 0xdebca48a, "icmp6_send" },
	{ 0x3b74985d, "ip_route_output_flow" },
	{ 0x3ffde166, "ip_route_input_noref" },
	{ 0x962f344a, "__icmp_send" },
	{ 0x33338211, "rcuref_get_slowpath" },
	{ 0x6e421feb, "gro_cells_receive" },
	{ 0xe438a9ce, "eth_type_trans" },
	{ 0xe113bbbc, "csum_partial" },
	{ 0xd9c97234, "__iptunnel_pull_header" },
	{ 0x6e009b8f, "metadata_dst_alloc" },
	{ 0x5ce82861, "dev_get_tstats64" },
	{ 0xf43fbb71, "param_ops_bool" },
	{ 0x5622fd2e, "module_layout" },
};

MODULE_INFO(depends, "tunnel6");


MODULE_INFO(srcversion, "1E6FE9775AA0FB82F55A1ED");
MODULE_INFO(rhelversion, "9.99");
